<template>
    <canvas id="canvas">

    </canvas>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Prop, Vue, Watch} from 'vue-property-decorator';
import {Painter, PainterConfig} from "src/classLibrary/Geometry/Painter";
import {ColoredFloorPlan, ColoredFloorPlanData} from "src/classLibrary/Geometry/Colored";


@Component
export default class FloorPlanCanvas extends Vue {
    @Prop() painterConfig!: PainterConfig;
    @Prop() coloredFloorPlan!: ColoredFloorPlanData;
    painter?: Painter

    @Watch('painterConfig')
    OnConfigChange() {
        this.draw();
    }

    draw() {

        if (this.coloredFloorPlan) {
            const a = new ColoredFloorPlan(this.coloredFloorPlan);
            this.painter?.Configure(this.painterConfig)
            this.painter?.Draw(a);
        }
    }

    @Watch('painterConfig')
    onPainterConfigChange() {
        this.draw();
    }

    @Watch('coloredFloorPlan')
    onFloorPlanChange() {

        this.draw();
    }

    async mounted() {
        const c = document.getElementById("canvas") as HTMLCanvasElement;
        const ctx = c.getContext("2d")!;
        this.painter = new Painter(this.painterConfig, ctx);
        this.draw();
    }


}
</script>
